#ifndef _DBMGR_H
#define _DBMGR_H

/**
      .
@memo   
@name dbmgr.h
@author (c) 2004-05 .. , .. 
@version \today
*/

#include "globals.h"
#include "config.h"

/*@{*/

/**
       
@name dbmgr.h_onstants
@memo    
*/

/*@{*/

/**
    0 () -EOF   \Ref{EOFmarker}.
@memo  -EOF
@see IsEOF EOFtuple
*/
#define EOFmarker	(-1)

/**
-EOF    ({\bf  NULL-!})  ,  
      ,     
 .
@memo -EOF
@see IsEOF EOFmarker fm_NextTuple
*/
extern tupleptr_t EOFtuple;

/*@}*/

/**
       
@name dbmgr.h_types
@memo    
*/

/*@{*/

typedef struct {
	char filename[FILENAME_LEN_MAX];
	int ary;
	long tuples;
	int fragmentattr;
	fragment_fn_t fragmentfn;
} fragment_t;

/**
         :

\begin{tabular}{lll}
{\bf N /}	& {\bf      }	& {\bf  } \\
1		& char filename[\Ref{FILENAME_LEN_MAX}]	&  ,      \\
2		& int ary			&  ( )  \\
3		& long tuples		&     \\
4		& int fragmentattr	&    (   1  \Ref{ATTRIBUTES_IN_RELATION}-1 ),       0         \\
5		& \Ref{fragment_fn_t} fragmentfn &     
\end{tabular}
@memo  
@see RELATIONS_IN_DATABASE FRAGMENTS_IN_RELATION ATTRIBUTES_IN_RELATION define_FRAGMENTATION_ATTRIBUTES dictionary_t
*/
typedef fragment_t _fragment_t; //     

typedef struct {
	fragment_t relations[RELATIONS_IN_DATABASE_MAX];
} dictionary_t;

/**
             
   ,    .    :

\begin{tabular}{lll}
{\bf N / }& {\bf      }	& {\bf  } \\
1			& \Ref{_fragment_t} relations[\Ref{RELATIONS_IN_DATABASE_MAX}] &      ( \Ref{RELATIONS_IN_DATABASE}   )
\end{tabular}
@memo  
@see RELATIONS_IN_DATABASE RELATIONS_IN_DATABASE_MAX _fragment_t
*/
typedef dictionary_t _dictionary_t; //     

/*@}*/

/**
      .
@name dbmgr.h_objects
@memo    
*/

/*@{*/

/**
     ,     
   (   ,      .).
@memo   
@see _dictionary_t
*/
extern dictionary_t DICTIONARY;

/*@}*/

/**
      .
@name dbmgr.h_functions
@memo    
*/

/*@{*/

/**
   ,    
 -EOF,      (  ,  {\bf ==NULL}).
 " "   ,     .
    -EOF,    c  \Ref{KEY_ATTRIBUTE}
    \Ref{domain_t}  \Ref{EOFmarker}.
@memo    EOF
@param tuple   
@return 1    -EOF,  0
@see fm_NextTuple tupleptr_t domain_t KEY_ATTRIBUTE EOFtuple
*/
extern int IsEOF(tupleptr_t tuple);

/**
               
  .        .
@memo    
@see db_OpenDatabase db_CloseDatabase
*/
extern void db_InitDatabaseManager(void);

/**
       .
@memo   
@see db_CloseDatabase
*/
extern void db_OpenDatabase(void);

/**
       .
@memo   
@see db_OpenDatabase
*/
extern void db_CloseDatabase(void);

extern int db_FragmentByDefault(tupleptr_t tuple, int fragmentattr);

/*@}*/

/*@}*/

#endif // _DBMGR_H