#ifndef _EXCHANGE_H
#define _EXCHANGE_H

/**
      EXCHANGE.
@memo   EXCHANGE
@name  exchange.h
@author (c) 2004-05 .. , .. 
@version \today
*/

#include "globals.h"
#include "config.h"

/*@{*/

/**
    EXCHANGE
@name exchange.h_constants
@memo     EXCHANGE
@see exchange.h_functions exchange.h_types
*/

/*@{*/

/**
      EXCHANGE (  ). 
@memo   EXCHANGE
@see MERGE GATHER SPLIT SCATTER JOIN RESTRICT SCAN STORE
*/
#define EXCHANGE	(5555)

/**
      MERGE ( ). 
@memo   MERGE
@see EXCHANGE GATHER SPLIT SCATTER
*/
#define MERGE	(EXCHANGE+10)

/**
      GATHER ( ). 
@memo   GATHER
@see EXCHANGE MERGE SPLIT SCATTER
*/
#define GATHER	(EXCHANGE+20)

/**
      SPLIT ( ). 
@memo   SPLIT
@see EXCHANGE MERGE GATHER SCATTER
*/
#define SPLIT	(EXCHANGE+30)

/**
      SCATTER ( ). 
@memo   SCATTER
@see EXCHANGE MERGE GATHER SPLIT
*/
#define SCATTER	(EXCHANGE+40)

/*@}*/

/**
    EXCHANGE
@name exchange.h_types
@memo     EXCHANGE
@see exchange.h_functions exchange.h_constants
*/

/*@{*/

typedef int (* distribute_fn_t)(tupleptr_t, int);

/**
   EXCHANGE   ,    
  .

  :
\begin{verbatim}
typedef int (* distribute_fn_t)(tupleptr_t, int);
\end{verbatim}
    :

\begin{tabular}{lll}
{\bf N / }	& {\bf 	}	& {\bf  } \\
1				& \Ref{tupleptr_t}	&    \\
2				& int				&  ,     --    0  \Ref{ATTRIBUTES_IN_RELATION}-1 
\end{tabular}

     int --   (..  
 ,       )    0  
\Ref{FRAGMENTS_IN_RELATION}-1 .
@memo      EXCHANGE
*/
typedef distribute_fn_t _distribute_fn_t;

/*@}*/

/**
   EXCHANGE
@name exchange.h_functions
@memo    EXCHANGE
@see exchange.h_types
*/

/*@{*/

/**
    EXCHANGE-     .
@memo   EXCHANGE
@param port    EXCHANGE
@param distributefn	   
@param ary   
@param fragmentattr  
@param fragmentfn    
@return         NULL   
@see _distribute_fn_t _fragment_fn_t
*/
extern treenode_t * MakeEXCHANGE(int port, distribute_fn_t distributefn, int ary, int fragmentattr, fragment_fn_t fragmentfn);

/*@}*/

/*@}*/

#endif // _EXCHANGE_H 

