/**
    ,         : 
     ,        .
@memo   
@name  dbmgr.h
@author (c) 2004-05 .. , .. 
@version 2.0  \today
@see dbmgr.h_type dbmgr.h_func
*/

#include "dbmgr.h"		//  
#include "omegacfg.h"	//  
#include "filemgr.h"	//   
#include "globals.h"	//   
#include "dbparams.h"
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <assert.h>

//  

static void CheckParams(void);	//    
static int db_FragmentFunc0(tupleptr_t tuple, int fragmentattr); //  0
static int db_FragmentFunc1(tupleptr_t tuple, int fragmentattr); //  1

// 



//  

typedef fragment_fn_t fragment_fn_array_t[FRAGMENTFN_NUM_MAX];

// 

dictionary_t DICTIONARY; //   

static fragment_fn_array_t FRAGMENTFN_ARRAY; //   

// 

tupleptr_t EOFtuple;
static int initflag=FALSE;

// 

/*
  (    )  ,    
 -EOF,     . NB!     , 
 ==NULL.
 " "   ,     .
    -EOF,        
 domain_t  EOFmarker.
@memo    EOF
@param tuple   
@return 1    -EOF,  0
*/
int IsEOF(tupleptr_t tuple)
{
	return (tuple==NULL ? FALSE : tuple[KEY_ATTRIBUTE]==EOFmarker);
}

/*
   
*/
void db_InitDatabaseManager(void)
{
	int i;
	char Rnum[2], Fnum[2];

	if (initflag)
		return;
	initflag=TRUE;

	CheckParams();

//    
	FRAGMENTFN_ARRAY[0]=db_FragmentFunc0;
	FRAGMENTFN_ARRAY[1]=db_FragmentFunc1;

//  
	sprintf(Fnum, "%d", WHOAMI);
	for (i=0; i<RELATIONS_IN_DATABASE; i++) {
		strcpy(DICTIONARY.relations[i].filename, "R");
		sprintf(Rnum, "%d", i);
		strcat(DICTIONARY.relations[i].filename, Rnum);
		strcat(DICTIONARY.relations[i].filename, "F");
		strcat(DICTIONARY.relations[i].filename, Fnum);
		strcat(DICTIONARY.relations[i].filename, ".TXT");

		DICTIONARY.relations[i].ary=ATTRIBUTES_IN_RELATION;
		DICTIONARY.relations[i].tuples=TUPLES_IN_FRAGMENT[i];
		DICTIONARY.relations[i].fragmentattr=FRAGMENTATION_ATTRIBUTES[i];
		DICTIONARY.relations[i].fragmentfn=FRAGMENTFN_ARRAY[FRAGMENTFN_NUM_DEFAULT];
	}

//   
	fm_InitFileManager();

//	 -EOF
	EOFtuple=(tupleptr_t) calloc(1, sizeof(domain_t));
	assert(EOFtuple!=NULL);
	EOFtuple[KEY_ATTRIBUTE]=EOFmarker;
}

/*
          .
      .
*/
static void CheckParams(void)
{
	int i;

	assert(strlen(PATH_TO_RELATIONS)<=PATHNAME_LEN_MAX);
	assert(RELATIONS_IN_DATABASE>=RELATIONS_IN_DATABASE_MIN && RELATIONS_IN_DATABASE<=RELATIONS_IN_DATABASE_MAX);
	assert(ATTRIBUTES_IN_RELATION>=ATTRIBUTES_IN_RELATION_MIN && ATTRIBUTES_IN_RELATION<=ATTRIBUTES_IN_RELATION_MAX);
	for (i=0; i<RELATIONS_IN_DATABASE; i++) {
		assert(TUPLES_IN_FRAGMENT[i]>=TUPLES_IN_FRAGMENT_MIN && TUPLES_IN_FRAGMENT[i]<=TUPLES_IN_FRAGMENT_MAX);
		assert(FRAGMENTATION_ATTRIBUTES[i]>=0 && FRAGMENTATION_ATTRIBUTES[i]<ATTRIBUTES_IN_RELATION && FRAGMENTATION_ATTRIBUTES[i]!=KEY_ATTRIBUTE);
		assert(FRAGMENTATION_FUNCS[i]>=0 && FRAGMENTATION_FUNCS[i]<FRAGMENTFN_NUM_MAX);
	}
}

/*
       .
@memo   
@return 0       
*/
void db_OpenDatabase(void)
{
	int i;

	assert(initflag==TRUE);
	for (i=0; i<RELATIONS_IN_DATABASE; i++) 
		fm_OpenRelation(i);
}

/*
       .
@memo   
*/
void db_CloseDatabase(void)
{
	int i;

	assert(initflag==TRUE);
	for (i=0; i<RELATIONS_IN_DATABASE; i++) 
		fm_CloseRelation(i);
}

/*
        . 
*/
static int db_FragmentFunc0(tupleptr_t tuple, int fragmentattr)
{
	assert(tuple!=NULL);
	assert(!IsEOF(tuple));
	assert(fragmentattr>=0 && fragmentattr<ATTRIBUTES_IN_RELATION);
	return tuple[fragmentattr]%FRAGMENTS_IN_RELATION;
}

/*
,  1
*/
static int db_FragmentFunc1(tupleptr_t tuple, int fragmentattr)
{
	assert(tuple!=NULL);
	assert(!IsEOF(tuple));
	assert(fragmentattr>=0 && fragmentattr<ATTRIBUTES_IN_RELATION);
	return tuple[fragmentattr]/(DOMAIN_VALUE_MAX/FRAGMENTS_IN_RELATION);
}

int db_FragmentByDefault(tupleptr_t tuple, int fragmentattr)
{
	assert(tuple!=NULL);
	assert(!IsEOF(tuple));
	assert(fragmentattr>=0 && fragmentattr<ATTRIBUTES_IN_RELATION);
	return tuple[fragmentattr]%FRAGMENTS_IN_RELATION;
}