/*
   ()   .
       .
@memo   
@name FileManager_Implementation
@author .. 
@version 1.0
@see DatabaseConfig Database
*/


#include "filemgr.h"	// 
#include "dbmgr.h"		//   
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <assert.h>

/*
@memo   
*/
typedef struct {
	int isopen;
	char filename[FILENAME_LEN_MAX+PATHNAME_LEN_MAX];
	FILE * f;
	tuple_t current;
	long processed;
} relation_t;


/*
@memo  
*/
typedef relation_t relationtab_t[RELATIONS_IN_DATABASE_MAX];

/*
@memo  
*/
static relationtab_t RELATIONTAB;

/*
@memo   
*/
static int initflag=FALSE;

/*
           .
          .
      .
@memo  
@param node  
*/
void fm_InitFileManager()
{
	int i;

	if (initflag)
		return;
	initflag=TRUE;

	for (i=0; i<RELATIONS_IN_DATABASE; i++) {
		RELATIONTAB[i].isopen=FALSE;
		strcpy(RELATIONTAB[i].filename, PATH_TO_RELATIONS);
		strcat(RELATIONTAB[i].filename, DICTIONARY.relations[i].filename);
	}
}

/*
      .
        .
@memo   
@param relation  
@return SUCCESS       
*/
void fm_OpenRelation(int relation)
{
	assert(initflag==TRUE);
	assert(relation>=0 && relation<RELATIONS_IN_DATABASE);
	assert(RELATIONTAB[relation].isopen==FALSE);

	RELATIONTAB[relation].isopen=TRUE;
	RELATIONTAB[relation].f=fopen(RELATIONTAB[relation].filename, "rt");
	assert(RELATIONTAB[relation].f!=NULL);
	RELATIONTAB[relation].processed=0;
}

/*
      .
        .
@memo   
@param relation  
*/
void fm_CloseRelation(int relation)
{
	assert(initflag==TRUE);
	assert(relation>=0 && relation<RELATIONS_IN_DATABASE);
	assert(RELATIONTAB[relation].isopen==TRUE);

	RELATIONTAB[relation].isopen=FALSE;
	fclose(RELATIONTAB[relation].f);
}

/*
      , ..    
  .
        fm_NextTuple  fm_EOF   , :
fm_OpenRelation(myrelation);
fm_ResetRelation(myrelation);
while (!fm_EOF(mytupleptr=fm_NextTuple(myrelation))) {
	 ,   mytupleptr
}
fm_CloseRelation(myrelation);
             fm_OpenRelation.
@memo    
@param relation  
*/
void fm_ResetRelation(int relation)
{
	assert(initflag==TRUE);
	assert(relation>=0 && relation<RELATIONS_IN_DATABASE);
	assert(RELATIONTAB[relation].isopen==TRUE);

	fclose(RELATIONTAB[relation].f);
	RELATIONTAB[relation].f=fopen(RELATIONTAB[relation].filename, "rt");
	assert(RELATIONTAB[relation].f!=NULL);
	RELATIONTAB[relation].processed=0;
}

/*
      .
        fm_ResetRelation  fm_EOF   , :
fm_OpenRelation(myrelation);
fm_ResetRelation(myrelation);
while (!EOF(mytupleptr=fm_NextTuple(myrelation))) {
	 ,   mytupleptr
}
fm_CloseRelation(myrelation);
@memo   
@param relation  
@return        -EOF,    
*/
tupleptr_t fm_NextTuple(int relation)
{
	int i;

	assert(initflag==TRUE);
	assert(relation>=0 && relation<RELATIONS_IN_DATABASE);
	assert(RELATIONTAB[relation].isopen==TRUE);

	if (RELATIONTAB[relation].processed==DICTIONARY.relations[relation].tuples) 
		RELATIONTAB[relation].current[KEY_ATTRIBUTE]=EOFmarker;
	else {
	    RELATIONTAB[relation].processed++;
		for (i=0; i<ATTRIBUTES_IN_RELATION; i++) {
			fscanf(RELATIONTAB[relation].f, "%ld\t", &RELATIONTAB[relation].current[i]);
// ,     
			assert(RELATIONTAB[relation].current[i]>=DOMAIN_VALUE_MIN);
			assert(RELATIONTAB[relation].current[i]<=DOMAIN_VALUE_MAX);
		}
		fscanf(RELATIONTAB[relation].f, "\n");
// ,      
		assert(WHOAMI==DICTIONARY.relations[relation].fragmentfn(RELATIONTAB[relation].current, DICTIONARY.relations[relation].fragmentattr));
	}
	return RELATIONTAB[relation].current;
}
