#include "jmerge.h"
#include "sort.h"
#include "bracket.h"	//   
#include "dbmgr.h"
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <assert.h>

/* INTERFACE */

/* Definitions: */

/*
 *   ,           .
*/
#define PACKET_SIZE_MAX (100)

#define TUPLECPY(dest, src, ary) memcpy(dest, src, ary*sizeof(domain_t))

#define RESCPY(node, tuple)	memcpy(node->result, tuple, node->ary*sizeof(domain_t))

/* Types: */

/*
 *   JOIN_MERGE (  )   :
 * buffer -    .
 * left -    .
 * currentelem -     .
 * ResetSign -     NextJOIN_Merge().
*/
typedef struct {
	tuple_t buffer[PACKET_SIZE_MAX];
	tuple_t left;
	long sizebuf;
	long currentelem;
	int ResetSign;
} JOIN_MERGE_cargo_t;
#define JOIN_MERGE_CARGO(treenode, attr)	((JOIN_MERGE_cargo_t *) JOIN_CARGO(treenode, supercargo))->attr

/* Variables: */

/* Function prototypes: */
void AssignJOIN_Merge(treenode_t * node);
void SetJOIN_Merge(treenode_t * node);
static tupleptr_t NextJOIN_Merge(treenode_t * node);
static void ResetJOIN_Merge(treenode_t * node);

/* IMPLEMENTATION*/

void SetJOIN_Merge(treenode_t * node)
{
	AssignJOIN_Merge(node);
	JOIN_CARGO(node, supercargo) = (JOIN_MERGE_cargo_t *) calloc(1, sizeof(JOIN_MERGE_cargo_t));
	assert(JOIN_CARGO(node, supercargo) != NULL);
	JOIN_MERGE_CARGO(node, ResetSign) = TRUE;

	return;
}

void AssignJOIN_Merge(treenode_t * node)
{

	assert(node != NULL);
	assert(node->rel_operation==JOIN);
	node->phys_operation=JOIN_MERGE;
	node->nextfn=(next_fn_t) NextJOIN_Merge;
	node->resetfn=(reset_fn_t) ResetJOIN_Merge;

}
 /*
  *   .
  *                 JOIN_MERGE
 */
static void ResetJOIN_Merge(treenode_t * node)
{
//	treenode_t *temp, *left, *right;

	assert(node!=NULL);
	if (JOIN_MERGE_CARGO(node, ResetSign))
		JOIN_MERGE_CARGO(node, ResetSign) = FALSE;
	else 
		return;
/*        ,  ,     .  */
//	left = MakeSORT(node->left->ary, JOIN_CARGO(node, attribute), node->fragmentattr, node->fragmentfn);					
//	assert(left != NULL);																									
//	temp = node->left;																										
//	node->left = left;																										
//	left->left = temp;																										
																															
//	right = MakeSORT(node->left->ary, JOIN_CARGO(node, attribute), node->fragmentattr, node->fragmentfn);					
																															
//	temp = node->right;																										
//	node->right = right;																									
//	right->left = temp;																										
																															
//	AssignSORT_Merge(left);																									
//	AssignSORT_Merge(right);																								
																															
/* ------------------------------------------------------------------------------------------------------------------------ */
	return;
}

/*
 *    .
*/
static tupleptr_t NextJOIN_Merge(treenode_t * node)

#define L node->left->result[JOIN_CARGO(node, attribute)]
#define R node->right->result[JOIN_CARGO(node, attribute)]
{
	JOIN_MERGE_cargo_t *Descriptor;
	long attr;
	int j, k=0;
	assert(node!=NULL);
	Descriptor = (JOIN_MERGE_cargo_t *) JOIN_CARGO(node, supercargo);
	assert(Descriptor != NULL);
	attr = JOIN_CARGO(node, attribute);
	if (node->left->isBOF)
	//           .
	{
		if (WHOAMI == 0)
			printf("\n--------------MERGE JOIN--------------\n");
		Descriptor-> sizebuf = 0;
		br_Next(node->left);
		br_Next(node->right);
	} /* isBOF */
	if (Descriptor->sizebuf == 0) /* sizebuf = 0   ,    */
	{
		do { /*       */
			if ((node->left->isEOF)||(node->right->isEOF)) {

				RESCPY(node,EOFtuple);
				while (!node->left->isEOF)
					br_Next(node->left);
				while (!node->right->isEOF)
					br_Next(node->right);

				return node->result;
			} /* if */
			if (L < R)
				br_Next(node->left);
			else
			if (L > R)
				br_Next(node->right);
		} while (L != R);

		TUPLECPY(Descriptor->left, node->left->result, node->left->ary);
		Descriptor->currentelem = 0;

		do { /*   */

			TUPLECPY(Descriptor->buffer[Descriptor->currentelem], node->right->result, node->right->ary);
			Descriptor->currentelem++;
			assert(Descriptor->currentelem < PACKET_SIZE_MAX);
			br_Next(node->right);

		} while ((L == R)&&(!node->right->isEOF));
		Descriptor->sizebuf = Descriptor->currentelem;
		Descriptor->currentelem = 0;
	} /* sizebuf = 0*/

	/*   */
	for (j=0; j<node->left->ary; j++)
		node->result[j]=Descriptor->left[j];
	for (j=0; j<JOIN_CARGO(node, attribute); j++)
		node->result[node->left->ary+j]=Descriptor->buffer[Descriptor->currentelem][j];
	for (j=JOIN_CARGO(node, attribute)+1; j<node->right->ary; j++)
		node->result[node->left->ary+j-1]=Descriptor->buffer[Descriptor->currentelem][j];
	/* //////////////////// */

	Descriptor->currentelem++;

	if (Descriptor->currentelem == Descriptor->sizebuf) //     .
	{

		br_Next(node->left);

		if ((L != Descriptor->buffer[0][attr]) || (node->left->isEOF)) 
		//            ,   
		//  .
			Descriptor->sizebuf = 0;
		else
		{
			TUPLECPY(Descriptor->left, node->left->result, node->left->ary);
			Descriptor->currentelem = 0;
		}
	}

	return node->result;
}
#undef L
#undef R

/* END. */