/*
    
.. , .. 
*/


#include "jnesloop.h"	//  
#include "globals.h"
#include "bracket.h"	//   
#include "dbmgr.h"
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>

/*
   JOIN   
@param node     
*/
static void ResetJOIN_NestedLoops(treenode_t * node);

/*
  JOIN   
@param node     
@return        , 
  ;     --   -EOF.
*/
static tupleptr_t NextJOIN_NestedLoops(treenode_t * node);

/*
           
   .
@memo    
@param node     
@see JOIN_NL
*/
void AssignJOIN_NestedLoops(treenode_t * node)
{
	assert(node!=NULL);
	assert(node->rel_operation==JOIN);

	node->phys_operation=JOIN_NESTEDLOOPS;
	node->nextfn=(next_fn_t) NextJOIN_NestedLoops;
	node->resetfn=(reset_fn_t) ResetJOIN_NestedLoops;
}

/*
  JOIN   
@param node     
@return        , 
  ;     --   -EOF.
*/
static tupleptr_t NextJOIN_NestedLoops(treenode_t * node)
{
/*
@memo     
@param node    
@param tuple   
*/
#define RESCPY(node, tuple)	memcpy(node->result, tuple, node->ary*sizeof(domain_t))
#define L	node->left->result
#define R	node->right->result

	int i;

	assert(node!=NULL);

	if (node->left->isBOF) 
		br_Next(node->left);
	
	if (node->left->isEOF) {
		RESCPY(node, EOFtuple);
		return node->result;
	}

	do {
		br_Next(node->right);
		if (node->right->isEOF) {
			br_Reset(node->right);
			br_Next(node->right);
			if (node->right->isEOF) {
				RESCPY(node, EOFtuple);
				return node->result;	
			}
			br_Next(node->left);
			if (node->left->isEOF) {
				RESCPY(node, EOFtuple);
				return node->result;
			}
		}
	} while (L[JOIN_CARGO(node, attribute)]!=R[JOIN_CARGO(node, attribute)]);

//    
	for (i=0; i<node->left->ary; i++)
		node->result[i]=L[i];
	for (i=0; i<JOIN_CARGO(node, attribute); i++)
		node->result[node->left->ary+i]=R[i];
	for (i=JOIN_CARGO(node, attribute)+1; i<node->right->ary; i++)
		node->result[node->left->ary+i-1]=R[i];

	return node->result;

#undef RESCPY
#undef L
#undef R
}

/*
  JOIN
@return SUCCESS       
*/
static void ResetJOIN_NestedLoops(treenode_t * node)
{
	assert(node!=NULL);
	return;
}



